from __future__ import annotations
from enum import IntEnum, auto


class UnitProperty(IntEnum):
    LIFE_POINTS = 1
    MAX_LIFE_POINTS = auto()
    MOVE_POINTS = auto()
    MAX_MOVE_POINTS = auto()
    ACTION_POINTS = auto()
    MAX_ACTION_POINTS = auto()

    MELEE_ATTACK = auto()
    MELEE_DEFENSE = auto()
    MELEE_RANGE = auto()

    BOW_ATTACK = auto()
    BOW_DEFENSE = auto()
    BOW_RANGE = auto()

    MOUNT_ATTACK = auto()
    MOUNT_DEFENSE = auto()
    MOUNT_RANGE = auto()

    SIEGE_ATTACK = auto()
    SIEGE_DEFENSE = auto()
    SIEGE_RANGE = auto()


attackUnitProperties = {
    UnitProperty.MELEE_ATTACK: {
        "defense": UnitProperty.MELEE_DEFENSE,
        "range": UnitProperty.MELEE_RANGE,
    },
    UnitProperty.BOW_ATTACK: {
        "defense": UnitProperty.BOW_DEFENSE,
        "range": UnitProperty.BOW_RANGE,
    },
    UnitProperty.MOUNT_ATTACK: {
        "defense": UnitProperty.MOUNT_DEFENSE,
        "range": UnitProperty.MOUNT_RANGE,
    },
    UnitProperty.SIEGE_ATTACK: {
        "defense": UnitProperty.SIEGE_DEFENSE,
        "range": UnitProperty.SIEGE_RANGE,
    },
}

